#!/usr/bin/perl -w 

# edit_post.cgi
#
# This script is part of Birch. It allows previous posts to be edited from the administration page.
#
# Copyright (c) 2006, Ross Harmes
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without modification, 
# are permitted provided that the following conditions are met:
# 
#	*	Redistributions of source code must retain the above copyright notice, 
#		this list of conditions and the following disclaimer.
#	*	Redistributions in binary form must reproduce the above copyright notice, 
#		this list of conditions and the following disclaimer in the documentation 
#		and/or other materials provided with the distribution.
#	*	Neither the name of View Software nor the names of its contributors may be 
#		used to endorse or promote products derived from this software without 
#		specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
# SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY 
# WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Changelog: 
#	2004.05.23: File created.
#	2006.01.02: Added custom photo sizes.

use strict;
use CGI; 

my $photo_dir =  "../Documents/photos";
my $thumb_dir =  "../Documents/thumbnails"; 
my $photo_list = "photos.xml";

my $q = new CGI; 

my (@line, $line_num, $num_of_posts, $changed_text, $caption, $orientation);

my $type =	$q->param("type");

if($type eq 'change') {
 
 	# Get the changes, and the dates to apply them to.
 
	my $post1_date = $q->param("post1_date");
	my $post1_text = $q->param("post1");
	
	$post1_text =~ s/[\n|\r]/ /g;
	$post1_text =~ s/&/&amp;/g;
	
	my $post2_date = $q->param("post2_date");
	my $post2_text = $q->param("post2");
	
	$post2_text =~ s/[\n|\r]/ /g;
	$post2_text =~ s/&/&amp;/g;
	
	my $post3_date = $q->param("post3_date");
	my $post3_text = $q->param("post3");
	
	$post3_text =~ s/[\n|\r]/ /g;
	$post3_text =~ s/&/&amp;/g;
	
	# Read the current photo list.
	
	open LIST, "$photo_list";
	while(<LIST>) { $line[$line_num++] = $_; }
	close LIST;
	
	# Change the captions for the given dates.
	
	$num_of_posts = $line_num;
	for($line_num = 0; $line_num < $num_of_posts; $line_num++) {
		
		if($line[$line_num] =~ /<date>(.*?)<\/date><caption>(.*?)<\/caption><orientation>(.*?)<\/orientation><width>(.*?)<\/width><height>(.*?)<\/height>/) {
			if($post1_date eq $1) { $line[$line_num] = "\t<post><date>" . $1 . "</date><caption>" . $post1_text . "</caption><orientation>" . $3 . "<\/orientation><width>" . $4 . "<\/width><height>" . $5 . "<\/height></post>\n"; }
			if($post2_date eq $1) { $line[$line_num] = "\t<post><date>" . $1 . "</date><caption>" . $post2_text . "</caption><orientation>" . $3 . "<\/orientation><width>" . $4 . "<\/width><height>" . $5 . "<\/height></post>\n"; }
			if($post3_date eq $1) { $line[$line_num] = "\t<post><date>" . $1 . "</date><caption>" . $post3_text . "</caption><orientation>" . $3 . "<\/orientation><width>" . $4 . "<\/width><height>" . $5 . "<\/height></post>\n"; }
			}
		
		$changed_text .= $line[$line_num]
		}
	
	# Write the changed text to the list.
	
	open LIST, ">$photo_list";
	print LIST $changed_text;
	close LIST; 

	print $q->redirect("/admin/");
	
	}
elsif($type eq 'open') {

	my $selected_post = $q->param("post-select");
	my ($date, $dimensions, $height, $width);
	my $class = "large";
	if($selected_post =~ /(.*?) ::/) { $date = $1; }
	
	# Read the current photo list.
	
	open LIST, "$photo_list";
	while(<LIST>) { $line[$line_num++] = $_; }
	close LIST;

	$num_of_posts = $line_num;
	for($line_num = 0; $line_num < $num_of_posts; $line_num++) {
	
		if($line[$line_num] =~ /<date>(.*?)<\/date><caption>(.*?)<\/caption><orientation>(.*?)<\/orientation><width>(.*?)<\/width><height>(.*?)<\/height>/) {
			if($date eq $1) { $caption = $2; $orientation = $3; $width = $4; $height = $5; }
			}
		}
	$dimensions = "width=\"" . $width . "\" height=\"" . $height . "\"";
	if($orientation eq 'vertical') { 
		$class = "large-vert";
		}
	
	# Print the HTML.	
		
	print $q->header ( ); 
	print <<END_OF_HTML

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd  ">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"> 
<head>
	<title>birch administration</title>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		
	<link rel="stylesheet" type="text/css" href="/includes/admin.css" />
	
</head>
<body>

<div id="content">

	<h1 id="title">Birch Administration :: <a href="/">Main</a></h1>
	
	<a href="#edit-post" onclick="return false;"  class="nav selected" 	id="edit-post-tab">Edit Post</a>	
	
	<div id="edit-post" class="section">
	
		<div id="stage-3">
		
			<form action="/cgi-bin/edit_post.cgi" method="post">

				<input type="hidden" name="type" value="submit" />
				<input type="hidden" name="date" value="$date" />

				<strong>Edit:</strong>
				<label for="caption">Caption</label>
				<br class="clear" />
				<div id="delete-option">
					<input type="checkbox" name="delete" id="delete-checkbox" />
					<label for="delete-checkbox">Delete Post</label>
				</div>
				<img src="/photos/$date.jpg" $dimensions alt="" class="$class" />
				<textarea class="enter-caption" name="caption">$caption</textarea>

				<input type="submit" value="Submit" class="submit" />

			</form>			
			
		</div>
			
	</div>

</div>

</body>
</html>

END_OF_HTML
;

	}
else {
	
 	# Get the changes, and the dates to apply them to.
 
	my $date = 	  $q->param("date");
	my $caption = $q->param("caption");
	
	$caption =~ s/[\n|\r]/ /g;
	$caption =~ s/&/&amp;/g;	
	
	# Read the current photo list.
	
	open LIST, "$photo_list";
	while(<LIST>) { $line[$line_num++] = $_; }
	close LIST;
		
	$num_of_posts = $line_num;
	
	if($q->param("delete")) { # If the delete checkbox was selected, delete the entry and the photos.
		
		for($line_num = 0; $line_num < $num_of_posts; $line_num++) {
		
			if($line[$line_num] =~ /<date>(.*?)<\/date><caption>(.*?)<\/caption>/) {
				if($date eq $1) { $line[$line_num] = ''; }
				}
			$changed_text .= $line[$line_num]		
			}
		
		unlink($photo_dir . "/" . $date . ".jpg");
		unlink($thumb_dir . "/" . $date . ".jpg");
		}
	else { # Else change the caption.
	
		for($line_num = 0; $line_num < $num_of_posts; $line_num++) {
		
			if($line[$line_num] =~ /<date>(.*?)<\/date><caption>(.*?)<\/caption><orientation>(.*?)<\/orientation><width>(.*?)<\/width><height>(.*?)<\/height>/) {
				if($date eq $1) { $line[$line_num] = "\t<post><date>" . $1 . "</date><caption>" . $caption . "</caption><orientation>" . $3 . "<\/orientation><width>" . $4 . "<\/width><height>" . $5 . "<\/height></post>\n"; }
				}
		
			$changed_text .= $line[$line_num]
			}
		}
	
	# Write the changed text to the list.
	
	open LIST, ">$photo_list";
	print LIST $changed_text;
	close LIST; 

	print $q->redirect("/admin/");	
	
	}