#!/usr/bin/perl -w 

# options.cgi
#
# This script is part of Birch. It is called from the administrator interface, and
# changes the available options.
#
# Copyright (c) 2006, Ross Harmes
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without modification, 
# are permitted provided that the following conditions are met:
# 
#	*	Redistributions of source code must retain the above copyright notice, 
#		this list of conditions and the following disclaimer.
#	*	Redistributions in binary form must reproduce the above copyright notice, 
#		this list of conditions and the following disclaimer in the documentation 
#		and/or other materials provided with the distribution.
#	*	Neither the name of View Software nor the names of its contributors may be 
#		used to endorse or promote products derived from this software without 
#		specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
# SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY 
# WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Changelog: 
#	2004.05.23: File created.

use Digest::MD5 qw(md5_hex);
use DB_File;
use CGI; 

use strict;

my $colophon =  "../colophon.html";
my $stylesheet_dir =  "../includes/"; 
my $stylesheet = "styles.css";
my $htpasswd_file = "../admin/.htpasswd";

my ($old_colophon);


my $q = new CGI; 

my $change = $q->param("change");

if($change eq 'template') {
 
 	my $new_stylesheet = $q->param("new_stylesheet");
 	
 	if($new_stylesheet ne '-----------------------------------------' and
 	   $new_stylesheet ne 'Select New Template') {
 	
 		$new_stylesheet .= ".css";
 		$new_stylesheet =~ s/ /_/g;	
 	
 		chdir $stylesheet_dir;
 		unlink $stylesheet;
 		`cp $new_stylesheet $stylesheet`;
 		}

	print $q->redirect("/admin/"); 
 	
	}
elsif($change eq 'colophon') {

	my $colophon_text = $q->param("colophon_text");
	
	open COLOPHON, "$colophon";
	while(<COLOPHON>) { $old_colophon .= $_; }
	close COLOPHON;
	
	$old_colophon =~ s/<div id="colophon">\n\n.*<\/div>\n<\/div>\n\n<\/body>/<div id="colophon">\n\n$colophon_text<\/div>\n<\/div>\n\n<\/body>/is;

	open COLOPHON, "> $colophon" or $old_colophon = $!;
	print COLOPHON $old_colophon;
	close COLOPHON;

	print $q->redirect("/admin/");

	}
elsif($change eq 'password') {

	my $current_user = $q->param("current_user");
	my $current_pass = $q->param("current_pass");
	my $new_user 	 = $q->param("new_user");
	my $new_pass 	 = $q->param("new_pass");
	
	# Remove old .htpasswd file.
	
	unlink($htpasswd_file);
	
	# Create new one.
	
	chdir("../admin/");
	`../cgi-bin/htpasswd.pl --userid $new_user --passwd $new_pass --writeover --dir ../admin/`;
	
	print $q->redirect("/admin/");
	}
	
	
	
	
# Error subroutine.
	
sub message {

	my $print_header = shift;
	my $message = shift;

	if($print_header) { print "Content-type: text/html\n\n"; }
    
	print q{<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd  ">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"> 
<head>
	<title>birch administration</title>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		
	<link rel="stylesheet" type="text/css" href="/includes/admin.css" />

</head>
<body>

<div id="login-content">

	<div id="login-header">
		<h1>Birch Administration</h1>
	</div>

	<div id="login-body">
		<div id="form-container">
};

     print "\t\t\t<h2 class=\"alert\">$message</h2>\n" .
     	   "\t\t\t<h3><a href=\"/admin/\">Return to login window</a><h3>\n";
	 print q{ 
		</div>
	</div>

</div>

</body>
</html>
};	


	}