#!/usr/bin/perl -w 

# upload.cgi
#
# This script is part of Birch. It uploads the new photo and it's thumbnail
# to the correct directories.
#
# Copyright (c) 2006, Ross Harmes
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without modification, 
# are permitted provided that the following conditions are met:
# 
#	*	Redistributions of source code must retain the above copyright notice, 
#		this list of conditions and the following disclaimer.
#	*	Redistributions in binary form must reproduce the above copyright notice, 
#		this list of conditions and the following disclaimer in the documentation 
#		and/or other materials provided with the distribution.
#	*	Neither the name of View Software nor the names of its contributors may be 
#		used to endorse or promote products derived from this software without 
#		specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
# SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY 
# WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Changelog: 
#	2004.05.21: File created.
#	2005.12.11: Added custom photo sizes.

use strict;
use CGI; 

my $photo_dir =  "../photos";
my $thumb_dir =  "../thumbnails"; 
my $photo_list = "photos.xml";

my $q = new CGI; 

my $stage =	$q->param("stage");

if($stage == 1) {
 
 	print $q->header(); 
 
	my $photo_upload = 	$q->upload("photo");
	my $thumb_upload = 	$q->upload("thumb");
	my $orientation =	$q->param("orientation");
	
	my $photo_width	=	$q->param("photo-width");
	my $photo_height =	$q->param("photo-height");
 
	my $filename = `date "+%Y_%m_%d_%H_%M_%S"` . ".jpg";
	my $dimensions = "width=\"" . $photo_width . "\" height=\"" . $photo_height ."\"";
	my $class = "large";

	$filename =~ s/\n//;	# Remove the newline the date function adds.

	open UPLOADFILE, ">$photo_dir/$filename";
	while (<$photo_upload>) { print UPLOADFILE; } 
	close UPLOADFILE; 

	open UPLOADFILE2, ">$thumb_dir/$filename";
	while (<$thumb_upload>) { print UPLOADFILE2; } 
	close UPLOADFILE2; 
	
	if($orientation eq 'vertical') { $class = "large-vert"; }

	print <<END_OF_HTML

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd  ">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"> 
<head>
	<title>birch administration</title>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		
	<link rel="stylesheet" type="text/css" href="/includes/admin.css" /> 
	
</head>
<body>

<div id="content">

	<h1 id="title">Birch Administration :: <a href="/">Main</a></h1>
	
	<a href="#new-post" onclick="return false;" class="nav selected" id="new-post-tab">New Post</a>
	
	<div id="new-post" class="section">
	
		<div id="stage-3">
			<form action="/cgi-bin/upload.cgi" method="post" name="stage3">

				<input type="hidden" name="stage" value="2" />
				<input type="hidden" name="filename" value="$filename" />
				<input type="hidden" name="orientation" value="$orientation" />
				<input type="hidden" name="width" value="$photo_width" />
				<input type="hidden" name="height" value="$photo_height" />

				<strong>Step 3:</strong>
				<label for="photo">Enter Caption</label>
				<img src="/photos/$filename" $dimensions alt="" class="$class" />
				<textarea class="enter-caption" name="caption" ></textarea>

				<input type="submit" value="Submit" class="submit" />

			</form>
		</div>
		
	</div>

</div>

</body>
</html>

END_OF_HTML
;
	}
elsif($stage == 2) {

	my $filename = 		$q->param("filename");
	my $orientation = 	$q->param("orientation");
	my $caption =  		$q->param("caption");
	
	my $width =			$q->param("width");
	my $height = 		$q->param("height");
	
	my $lines_read = '';
	
	$filename =~ s/\.jpg//;
	$caption =~ s/[\n|\r]/ /g;
	$caption =~ s/&/&amp;/g;
	
	open LIST, "$photo_list";
	
	while(<LIST>) { $lines_read .= $_; }
	
	close LIST;
	
	open LIST, ">$photo_list";
	
	$lines_read =~ s/<\?xml version="1\.0" encoding="utf-8"\?>\n<!DOCTYPE photo_list SYSTEM "\/cgi-bin\/photo_list.dtd">\n<photo_list>\n//;
	
	$lines_read = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n" .
				  "<!DOCTYPE photo_list SYSTEM \"/cgi-bin/photo_list.dtd\">\n" .
				  "<photo_list>\n" .
				  "\t<post><date>$filename</date><caption>$caption</caption><orientation>$orientation</orientation><width>$width</width><height>$height</height></post>\n" .
				  $lines_read;
	
	print LIST $lines_read;
	
	close LIST; 

	print $q->redirect("/");
	}
